» » » Установка Deluge Daemon на сервер

Установка Deluge Daemon на сервер

Author: Tatyana dated 14-05-2013, 14:49
  • Dislike
  • +1
  • Like
Я уже писала, как поднять торрент-клиент на сервере на примере Transmission. Теперь же мы рассмотрим более сложный, но вместе с тем и более функциональный, на мой взгляд, вариант.

Deluge — клиент-сервер для передачи данных по протоколу BitTorrent, созданный на Python и GTK+.
Deluge поддерживает следующие сетевые возможности:
  • Mainline DHT.
  • µTorrent Peer exchange (обмен пирами по протоколу μTP).
  • Local service discovery (обнаружение пиров в локальной сети).
  • BitTorrent шифрование протокола. UPnP и NAT-PMP.
  • Поддержка прокси для пиров, трекеров, DHT и Web-Seed.
  • Шифрование.
  • Частные торренты.
  • Ручное добавление пиров.

Кроме того, Deluge обладает следующими функциями:
  • Режимы полного и компактного резервирования дискового пространства для загрузок.
  • Ограничение скорости приёма-передачи как для отдельных закачек, так и глобальное.
  • Выбор отдельных файлов из раздачи для загрузки.
  • Приоритет скачивания первой и последней части файла для возможности предварительного просмотра содержимого.
  • Выбор глобального каталога для скачивания и отдельных каталогов для конкретных заданий.
  • Переименование скачиваемых файлов и каталогов.
  • Очередь системы для повышения эффективности управления полосой пропускания.
  • Автоматическая остановка или удаление раздачи по достижении определённого рейтинга.
  • Минимизация в системный трей с возможностью парольной защиты.

Варианты интерфейса.
  • deluge-gtk или deluge — классическая версия Deluge с графическим интерфейсом пользователя.
  • deluge-console — альтернативный вариант Deluge с текстовым интерфейсом пользователя не требует запущенного X.org.
  • deluge-web — веб-интерфейс программы.
  • deluged — демон, который сидирует и докачивает активные раздачи, не поставленные ранее на паузу. Не предоставляет пользователю производить какие-либо действия, но зато сводит потребление программой ресурсов системы до минимума, если в данный момент кроме раздачи и закачки никаких действий не требуется.


Нас интересует вариант «демон + web-интерфейс». В моём случае имеется желание и сервер в локальной сети на Debian 7, с которым я соединяюсь через терминал по SSH. Расположение сервера не важно. Предложенный вариант работает одинаково стабильно и в случае, если сервер располагается во внешней сети.
Устанавливаем демон и webUI.
aptitude install deluged deluge-webui

Теперь нам нужно определиться от имени какого пользователя будет работать демон. В моём случае это существующий пользователь (условно user). Если вы хотите создать нового пользователя (условно deluge), то вы можете это сделать следующей командой:
adduser --disabled-password --system --home /home/deluge --group deluge

То есть мы создали пользователя deluge, входящего в группу deluge и имеющего домашний каталог по адресу /home/deluge.
Этот шаг можно пропустить, если вы хотите чтоб демон работал от имени существующего пользователя.
Для запуска демона и web-интерфейса Deluge при загрузке сервера нам понадобится init.d скрипт. К счастью для нас, некий Adolfo R. Brandes уже написал этот скрипт и нам остаётся лишь слегка подправить его и скопировать в нашу init.d директорию.
Для начала любым удобным способом создаём файл «deluge-daemon» в директории /etc/default, например с помощью nano.
nano /etc/default/deluge-daemon

Пишем там следующее:

# Configuration for /etc/init.d/deluge-daemon

# The init.d script will only run if this variable non-empty.
DELUGED_USER=""             # !!!CHANGE THIS!!!!

# Should we run at startup?
RUN_AT_STARTUP="YES"


В строке DELUGED_USER=""указываем пользователя, от которого будет работать Deluge. Например DELUGED_USER="user", после чего сохраняем и закрываем файл (Ctrl+X, затем Y).
Тем же способом создаём файл «deluge-daemon» в директории /etc/init.d следующего содержания:

 
#!/bin/sh
### BEGIN INIT INFO
# Provides:          deluge-daemon
# Required-Start:    $local_fs $remote_fs
# Required-Stop:     $local_fs $remote_fs
# Should-Start:      $network
# Should-Stop:       $network
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Daemonized version of deluge and webui.
# Description:       Starts the deluge daemon with the user specified in
#                    /etc/default/deluge-daemon.
### END INIT INFO

# Author: Adolfo R. Brandes 

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DESC="Deluge Daemon"
NAME1="deluged"
NAME2="deluge"
DAEMON1=/usr/bin/deluged
DAEMON1_ARGS="-d -L warning -l /var/log/deluge/daemon/warning.log"  
DAEMON2=/usr/bin/deluge-web
DAEMON2_ARGS="-L warning -l /var/log/deluge/web/warning.log" 
PIDFILE1=/var/run/$NAME1.pid
PIDFILE2=/var/run/$NAME2.pid
UMASK=022                     # Change this to 0 if running deluged as its own user
PKGNAME=deluge-daemon
SCRIPTNAME=/etc/init.d/$PKGNAME

# Exit if the package is not installed
[ -x "$DAEMON1" -a -x "$DAEMON2" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$PKGNAME ] && . /etc/default/$PKGNAME

# Load the VERBOSE setting and other rcS variables
[ -f /etc/default/rcS ] && . /etc/default/rcS

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

if [ -z "$RUN_AT_STARTUP" -o "$RUN_AT_STARTUP" != "YES" ]
then
   log_warning_msg "Not starting $PKGNAME, edit /etc/default/$PKGNAME to start it."
   exit 0
fi

if [ -z "$DELUGED_USER" ]
then
    log_warning_msg "Not starting $PKGNAME, DELUGED_USER not set in /etc/default/$PKGNAME."
    exit 0
fi

#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --exec $DAEMON1 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
   RETVAL1="$?"
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --exec $DAEMON2 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK --test > /dev/null
   RETVAL2="$?"
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 1

   start-stop-daemon --start --background --quiet --pidfile $PIDFILE1 --make-pidfile --exec $DAEMON1 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON1_ARGS
   RETVAL1="$?"
        sleep 2
   start-stop-daemon --start --background --quiet --pidfile $PIDFILE2 --make-pidfile --exec $DAEMON2 \
      --chuid $DELUGED_USER --user $DELUGED_USER --umask $UMASK -- $DAEMON2_ARGS
   RETVAL2="$?"
   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred

   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER --pidfile $PIDFILE2
   RETVAL2="$?"
   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --user $DELUGED_USER --pidfile $PIDFILE1
   RETVAL1="$?"
   [ "$RETVAL1" = "2" -o "$RETVAL2" = "2" ] && return 2

   rm -f $PIDFILE1 $PIDFILE2

   [ "$RETVAL1" = "0" -a "$RETVAL2" = "0" ] && return 0 || return 1
}

case "$1" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME1"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME1"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  restart|force-reload)
   log_daemon_msg "Restarting $DESC" "$NAME1"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac

:


Оригинал можно взять от сюда.
Делаем скрипт исполняемым
chmod a+x /etc/init.d/deluge-daemon

И указываем на загрузку при старте системы
update-rc.d deluge-daemon defaults

Запускаем daemon
invoke-rc.d deluge-daemon start

Строки «DAEMON1_ARGS=» и «DAEMON2_ARGS=» в нашей конфигурации указывают на логирование. Создайте соответствующие файлы в соответствующих директориях, либо приведите эти строки в соответствие с оригинальным скриптом автора, если не хотите использовать логи. Следует учесть, что пользователь, от имени которого работает Deluge, должен иметь права на запись в файлах «warning.log» этих директорий. Возможные уровни логирования: none, critical, error, warning, info, debug
Определяем ротацию логов (пропускаем этот шаг, если не хотим использовать логи):
cat > /etc/logrotate.d/deluge << EOF 
/var/log/deluge/*/*.log {
        weekly
        missingok
        rotate 7
        compress
        notifempty
        copytruncate
        create 600
}
EOF

Перезагружаем нашу связку
/etc/init.d/deluge-daemon restart

и заходим в web-интерфейс по адресу http://10.10.1.25:8112

Естественно, вместо 10.10.1.25 указываем адрес своего сервера. Пароль по умолчанию: «deluge». В менеджере подключений, если таковой явится вам после ввода пароля, выбираем нужный демон (он у вас один) и соединяемся, после чего переходим к настройкам нашего BitTorrent клиента.
Собственно, через WebUI можно управлять клиентами на множестве серверов. А так же клиентом на сервере можно управлять через GTK интерфейс Deluge с локального компьютера, о чём я расскажу в следующий раз.
____________
По материалам Linux Home Serverguide и официальной Wiki Deluge
Like Dislike




Tags: Deluge BitTorrent Debian Linux


 
  • Creative Commons Licence
  • Norton Safeweb
  • Powered by MariaDB
  • Powered by Debian
  • Website Uptime Monitoring By ServiceUptime.com
  • Yandex.Metrica